
//Problema:

/*

Considerem una cua de parells de naturals, on cada parell conté un
identificador i un valor.

La cua representa persones (identificadors) que esperen davant d'un mostrador 
per realizar alguna gestió que té el cost en temps indicat (valor). 

En un cert moment, s'obre un nou punt d'atenció i les persones s'han
de distribuir de forma justa en dues noves cues tenint en compte el
temps de les gestions implicades.

Una distribució (c1, c2) es justa respecte d'una cua original c si
ningú ha d'esperar més que una altra persona que tenia darrera a c i
tothom espera el mínim temps possible.

*/

//Pre: c=C i c1 i c2 són buides
void distribucio(queue<pair<int,int> > & c; 
		 queue<pair<int,int> > & c1; queue<pair<int,int> > & c2);

//Post: c1 i c2 són una distribució justa dels elements de C





//Com el resoldrem = Invariant:

/*{Inv: c1 i c2 són una distribució justa dels elements C que no són a c
        e1 és el temps d'espera a c1
        e2 és el temps d'espera a c2
 */


/*
1) Inicialitzacions


int e1=0;
int e2=0;


Justificació:

Com que c conté tots el element de C, c1 i c2, que són buides, són una
distribució justa de la llista buida;
e1 = 0 és el temps d'espera de la cua buida.
e2 igual
*/


/*
2)Cos del bucle


 if (e1 > e2) {
  c2.push(c.front());
  e2+=c.front().second;
 }
 else {
  c1.push(c.front());
  e1+=c.front().second;
 }
 c.pop();


//Justificació:


c1 i c2 són una distribució justa dels elements C que no són a c. Com que al acabar treiem el primer element de c, cal que el guardem a c1 o a c2 de manera que la distribució sigui justa amb el primer element de c;

c1 i c2 són una distribució justa, el seus element esperen el menys
temps possible.  Per tant, les esperes e1 i e2 son més grans o iguals
que l'espera de tots els element de c1 i c2. 

Si l'espera és superior a c1 (és a dir e1>e2), la mínima espera s'obté
posant l'element a c2. Per tant, l'afegim a c2 i el nou temps d'epera
de c2, que hem de tenir a e2, s'ha dincrementar amb el temps de
l'element afegit (el primer de c). Si l'espera a c1 és menor o igual,
fem el mateix raonament amb c1.

Finalment eliminem el primer i tenim que tornen a complir l'invariant.

*/

/*

3) Condició de sortida:

while (not c.empty())

Justificació


Si c és buida c1 i c2 són una distribució justa de tots els elements de C

*/


/*

4) Acabament:

la mesura que decreix és la mida de c;

A cada volta decreix en un

*/



//Algorisme:


//Pre: c=C i c1 i c2 són buides
void distribucio(queue<pair<int,int> > & c; 
		 queue<pair<int,int> > & c1; queue<pair<int,int> > & c2);
int e1=0;
int e2=0;


/*{Inv: c1 i c2 són una distribució justa dels elements C que no són a c
        e1 és el temps d'espera a c1
        e2 és el temps d'espera a c2
 */
while (not c.empty()){

 if (e1 > e2) {
  c2.push(c.front());
  e2+=c.front().second;
 }
 else {
  c1.push(c.front());
  e1+=c.front().second;
 }
 c.pop();

 }
//Post: c1 i c2 són una distribució justa dels elements de C



